// C Source File
// Created 8/2/01; 1:29:16 PM

//AutoStart Copyright (c) 2001 by Greg Dietsche.
//see AutoStart.txt for more information.

#define OPTIMIZE_ROM_CALLS
#include <tigcclib.h>

#include "Main.h"
#include "Misc.h"
#include "AutoStart.h"

void EventHandler(EVENT *ev)
{

	void (*OldHook)(EVENT*);
	
	
	#ifdef OPTIMIZE_ROM_CALLS
		void *__saved_a5__;//a variable to save the register a5 so it can be restored later
		asm("/*START: Support for OPTIMIZE_ROM_CALLS*/");
		asm("move.l %%a5,%0":"=p"(__saved_a5__));
		asm("move.l 0xC8,%a5");
		asm("/*END: Support for OPTIMIZE_ROM_CALLS*/");
	#endif

	if(ev->Type==CM_KEYPRESS)	
	{	
		short c = ev->extra.Key.Code;
		
		if((ghsWin->Flags & WF_ACTIVE) && (ghste->Flags & TE_ACTIVE))
			if(c==KEY_ENTER || c==KEY_ENTER+(short)KEY_DIAMOND)
				AutoStart();
	}
  
  (unsigned long*)OldHook=*((unsigned long*)gpOldHandler);
  
  if(OldHook)
  	asm("								/*This inline asm takes the place of OldHook(ev);
  												the difference is that a2 will also contain ev
  												as a parameter to support TEOS. Without this code,
  												you would need to use the switch -ffixed a2 when
  												compiling this example.*/
  	move.l %0,%%a2			/*TEOS expects the parameter to be in a2*/
  	move.l %%a2,-(%%sp)	/*other event hooks expect it on the stack*/
  	move.l %1,%%a0			/*Get the address to call*/
  	jsr (%%a0)					/*Call the next event hook*/
  	addq.l #4,%%sp			/*restore the stack*/
  	"::"p"(ev),"g"(OldHook):"a0","a2");

	#ifdef OPTIMIZE_ROM_CALLS
		asm("/*START: Support for OPTIMIZE_ROM_CALLS*/");
		asm("move.l %0, %%a5	/*support for OPTIMIZE_ROM_CALLS*/"::"p"(__saved_a5__));
		asm("/*END: Support for OPTIMIZE_ROM_CALLS*/");
	#endif

}
