// BETA-VERSION+++BETA-VERSION+++BETA-VERSION+++BETA-VERSION+++BETA-VERSION+++
// BETA-VERSION+++BETA-VERSION+++BETA-VERSION+++BETA-VERSION+++BETA-VERSION+++
// BETA-VERSION+++BETA-VERSION+++BETA-VERSION+++BETA-VERSION+++BETA-VERSION+++
// BETA-VERSION+++BETA-VERSION+++BETA-VERSION+++BETA-VERSION+++BETA-VERSION+++


/******************************************************************************
*
* project name:    TIGCC Tools Suite
* file name:       ttstart.c
* initial date:    14/08/2000
* author:          thomas.nussbaumer@gmx.net
* description:     start utility for exepacked and/or normal executables
*
* =============================================================================
* IMPORTANT NOTE
* =============================================================================
*
* This program uses many really dirty tricks to overcome some restrictions of
* the AMS. Don't take it as example how to code (dirty tricks are NOT smart!)
*
* The special RETURN_VALUE treatment exit is, of course, the most dirty part.
* It's correctnes can ONLY be guaranteed for TIGCC 0.91 with optimization
* setting -Os !!!!
*
* And: Don't modify the source when you haven't complete understand it!
*
*
* =============================================================================
* Usage info - normal build (tigcc -Os ttstart.c)
* =============================================================================
*
* When ttstart is build "normally" it can be used to start either exepacked or
* normal executables on TI-89/TI-92plus running AMS versions up to 2.05.
* To start a program (for example: myprog.ppg or myprog.ASM) just type:
* ttstart("myprog")
* (NOTE: the quotes around the program name!)
* If you want to hand-over some commandline parameters to the started program
* just specify them after the programname like this: ttstart("myprog",10,20)
* The program name itself is removed from the estack by ttstart. The started
* program will only see the additionally parameters of ttstart.
*
* Additionally:
*
* ttstart is the first available launcher which handles return values from the
* started program to the AMS correctly.
*
*
* =============================================================================
* customizing ttstart (generating own, special purpose launchers)
* =============================================================================
*
* -----------------------------------------------------------------------------
* (1) using a predefined filename
* -----------------------------------------------------------------------------
*
* if you want to build a launcher which automatically starts a predefined
* program you can use the TIGCC commandline option -DCUSTOM_NAME=name_of_file
* For example: if you want to build a launcher with name mylaunch which should
* automatically start myprog.ppg compile ttstart like this:
*
* tigcc -Os -DCUSTOM_NAME=myprog -o mylaunch
*
* After uploading mylaunch and myprog to your calc you can simply start myprog
* by just typing: mylaunch()
* You can also hand-over any parameter to myprog. For example: mylaunch(10,20)
* starts myprog with parameter 10 and 20 on the estack.
*
* -----------------------------------------------------------------------------
* (2) customizing the type of program (normal or exepacked)
* -----------------------------------------------------------------------------
*
* It doesn't make much sense to build a launcher with a predefined filename,
* but without customizing the type of the program, too.
* If you build a launcher for your program and the program is NOT exepacked,
* the launcher will still contain the unpacking code (around 1200 bytes) which
* is not necessary. Therefore you can use commandline option -DONLY_PPG
* for exepacked programs or -DONLY_ASM for normal program.
*
* -------- Example 1 - launcher for myprog.ppg --------
*
* tigcc -Os -DCUSTOM_NAME=myprog -DONLY_PPG -o mylaunch
*
* -------- Example 2 - launcher for myprog.asm --------
*
* tigcc -Os -DCUSTOM_NAME=myprog -DONLY_ASM -o mylaunch
*
* -----------------------------------------------------------------------------
* (3) memory leak detection support (-DLEAKWATCH)
* -----------------------------------------------------------------------------
*
* When you compile ttstart with option -DLEAKWATCH it will check if the
* available memory get changed by the started program. If the memory is changed
* it will output the difference in the status ine.
*
*
* =============================================================================
* TIGCC -pack option (how to make a new pstarter.s file)
* =============================================================================
*
* Since version 0.90 TIGCC features option -pack which generates automatically
* exepacked programs including a custom launcher program.
* The ASM sourcecode of the custom launcher (pstarter.s) used by TIGCC can be
* found in directory include/c of your TIGCC installation.
* pstarter.s can be easily generated from ttstart.c:
*
* (1) compile ttstart.c this way:
*     tigcc -Os -DCUSTOM_NAME=tempprog -DONLY_PPG ttstart.c -S
* (2) rename generated ASM file ttstart.c into pstarter.s
* (3) backup old pstarter.s from directory include/c of your TIGCC
*     installation
* (4) copy the newly generated file pstarter.s over the old one
*     in directory include/c of your TIGCC installation
*
*
* =============================================================================
* How to generate exepacked programs
* =============================================================================
*
* The simplest way to generate an exepack program is, of course, the -pack
* option of TIGCC (examine the TIGCC docs).
* The second way to generate an exepack program from ANY executable (even from
* kernel-dependent programs) is to use tool ttppggen from the TIGCC Tools
* Suite.
*
*
* =============================================================================
* CREDITS
* =============================================================================
*
* (1) Zeljko Juric, for the "normal launcher" code from the TIGCC-FAQ and the
*     code which overcomes the RETURN_VALUE problem
* (2) Kevin Kofler, for the idea how to handle RETURN_VALUE in the context of a
*     launcher correctly
* (3) Greg Dietsche, for various suggestions (normal program handling etc.)
* (4) Me (Thomas Nussbaumer), for anything else
*
* $Id: ttstart.c,v 1.9 2001/07/31 22:56:59 Thomas Nussbaumer Exp $
*
******************************************************************************/

#define OPTIMIZE_ROM_CALLS
#include <statline.h>
#include <alloc.h>
#include <vat.h>
#include <string.h>
#include <system.h>

#ifndef CUSTOM_NAME
#include <args.h>
#endif
short _ti92plus;
short _ti89;


#define fatal(s) {ST_showHelp(s); return;}

//-----------------------------------------------------------------------------
// if -DONLY_ASM and -DONLY_PPG is given undefine both (trivial)
//-----------------------------------------------------------------------------
#ifdef ONLY_ASM
#ifdef ONLY_PPG
#undef ONLY_ASM
#undef ONLY_PPG
#endif
#endif

#ifndef ONLY_ASM
#include "ttunpack.h"    // errorcodes definition
#endif

//-----------------------------------------------------------------------------
// we use an own implementation of enter_ghost_space, because due to the
// arrangements within TIGCCLIB (comes as real compile-time library since 2.4)
// otherwise we cannot generate a compatible pstarter.s anymore
// (the launcher generated with option -pack will not be linked against
// tigcc.a)
//-----------------------------------------------------------------------------
void own_enter_ghost_space(void);
asm("own_enter_ghost_space:movea.l 0xC8,%a0
     cmpi.l #1000,(%a0,-4)
     bcs.s 1f
     movem.l %a0-%a6/%d0-%d7,-(%sp)
     lea (%sp,-20),%sp
     move.l #0x3E000,%a3
     move.w (%a3),-(%sp)
     move.l (%a3,2),-(%sp)
     move.l %a0,%d0
     andi.l #0x600000,%d0
     addi.l #0x20000,%d0
     move.l %d0,(%sp,12)
     move.l %d0,(%sp,16)
     trap #0xC
     move.w #0x2700,%sr
     move.l #0xF,%d3
     move.l %a3,-(%sp)
     clr.w  -(%sp)
     lea 0f(%pc),%a0
     adda.l #0x40000,%a0
     move.w #0x4EF9,(%a3)
     move.l %a0,(%a3,2)
     move.l 0xAC,%a0
     jmp (%a0)
0:   move.l (%sp)+,0x3E002
     move.w (%sp)+,0x3E000
     lea (%sp,20),%sp
     movem.l (%sp)+,%a0-%a6/%d0-%d7
1:   move.l (%sp)+,%a0
     adda.l #0x40000,%a0
     jmp (%a0)");


//-----------------------------------------------------------------------------
// The following macro calls function fptr and treats a possible RETURN_VALUE
// correctly. If a return value is available mode is set to 0, otherwise 1
//
// NOTE: the NOPs are very important due to a dirty hack in the TIGCCLIB with
//       define RETURN_VALUE (they must be exactly after the call!!)
//
// The method below BELIEVES that register d3 is NOT trashed by the called
// program. WILL THIS ALWAYS HOLD TRUE ????
//-----------------------------------------------------------------------------

#define ASM_CALL_WITH_RETURN_VALUE_HANDLING(fptr,mode) ({\
        asm volatile ("movem.l %%d1-%%d7/%%a0-%%a6,-(%%sp);"\
            "jsr (%1);"\
            "bra.s 0f;"\
            "nop;nop;"\
            "clr.b %%d0;"\
            "bra.s 1f;"\
            "0: st.b %%d0;"\
            "1: movem.l (%%sp)+,%%d1-%%d7/%%a0-%%a6;"\
            "move.b %%d0,%0"\
            : "=d" (mode) : "a" ((void *)(fptr)) : "d0");})

//-----------------------------------------------------------------------------
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// DIRTY-DIRTY-DIRTY
//
// The special treatment of RETURN_VALUE makes it necessary to hard-code the
// registers which should be restored before the special exit!
//
// THIS IS COMPLETELY COMPILER-VERSION AND OPTIMIZATION SETTINGS DEPENDENT !!!!
//
// compiles correctly ONLY with TIGCC 0.91 and optimization -Os
//
// NOTE: If you make any changes to this sourcecode compile the program
//       afterwards with -S to get the ASM output and check the movm.l
//       instructions at the end. Both movm.l instructions MUST BE the same.
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//-----------------------------------------------------------------------------
#ifdef ONLY_ASM
   #ifdef LEAKWATCH
   #define DIRTY_RESTORE_REGS "movm.l -84(%a6),#0x1cf8;"
   #else
   #define DIRTY_RESTORE_REGS "movm.l -72(%a6),#0x1c18;"
   #endif
#elif ONLY_PPG
   #ifdef LEAKWATCH
   #define DIRTY_RESTORE_REGS "movm.l -76(%a6),#0x1c38;"
   #else
   #define DIRTY_RESTORE_REGS "movm.l -68(%a6),#0xc18;"
   #endif
#else
   #ifdef LEAKWATCH
   #define DIRTY_RESTORE_REGS "movm.l -88(%a6),#0x1cf8;"
   #else
   #define DIRTY_RESTORE_REGS "movm.l -80(%a6),#0x1c78;"
   #endif
#endif



//=============================================================================
// nothing special, just a huge main routine ...
//=============================================================================
void _main(void) {
    unsigned char*         src;
    unsigned char*         dest;
    unsigned short         length;
    char                   tmpstr[50];
    char*                  fname;
    SYM_ENTRY*             symptr;
    HANDLE                 h;
    volatile unsigned char mode;
#ifndef ONLY_PPG
    unsigned short         asm_prg  = 0;
    unsigned short         do_alloc = 1;
#endif

#ifdef LEAKWATCH
    long freemem = (long)HeapAvail();
#endif

#ifndef CUSTOM_NAME
    //-------------------------------------------------------------------------
    // Here comes the first "DIRTY, DIRTY, DONT-DO-IT-NORMALLY" hack:
    //
    // We are not using a copy of the top_estack pointer, but we operate
    // directly on the top_estack pointer itself. This way the called program
    // will not "see" its own program name on the estack !!!!
    //
    // NOTE: due to the "nature" of the estack it is not necessary to restore
    //       the top_estack pointer to its original value
    //-------------------------------------------------------------------------
    if (GetArgType(top_estack) != STR_TAG) fatal("use: ttstart(\"name\")");
    fname = GetStrnArg(top_estack);

    // suggestion from Greg Dietsche: if given filename contains a '(' truncate
    // the string there. This becomes useful if someone uses a auto-completion
    // TSR
    if ((src = strchr(fname,'('))) *src = 0;
#else
    //-------------------------------------------------------------------------
    // if you can figure out why the next lines are that strange, then you are
    // really good in C programming ...
    //-------------------------------------------------------------------------
    #define TOSTR(x) #x
    #define XTOSTR(x) TOSTR(x)

    fname = XTOSTR(CUSTOM_NAME);
#endif

    //-------------------------------------------------------------------------
    // setup TIOS name for variable and try to find it in the current folder ..
    //-------------------------------------------------------------------------
    tmpstr[0] = 0;
    strcpy(tmpstr+1,fname);
    if (!(symptr = DerefSym(SymFind(tmpstr+1+strlen(fname))))) {
        sprintf(tmpstr,"%s not found",fname);
        fatal(tmpstr);
    }

    //-------------------------------------------------------------------------
    // IMPORTANT: only use handle (symptr may become invalid !!!)
    //-------------------------------------------------------------------------
    h = symptr->handle;

    //-------------------------------------------------------------------------
    // if file is already locked, don't lock it again ...
    //-------------------------------------------------------------------------
    if (HeapGetLock(h)) {
        src = HeapDeref(h);
        h   = 0;
    }
    else {
        src = HLock(h);
    }
    if (!src) fatal("locking failed");

    length = *(unsigned int*)src+3;
    dest   = src+length-2;

#ifndef ONLY_PPG
    //-------------------------------------------------------------------------
    // check if we want to start a normal ASM program
    //-------------------------------------------------------------------------
    if (*dest == 0xF3) {
        asm_prg = 1;
        dest    = src;
        length--;
        if (!symptr->flags.bits.archived && !symptr->flags.bits.locked) do_alloc = 0;
    }
#endif

#ifdef ONLY_ASM
    else {
        if (h) HeapUnlock(h);
        fatal("no ASM file");
    }

#else

    //-------------------------------------------------------------------------
    // check if given program is not even a packed file
    //-------------------------------------------------------------------------
#ifndef ONLY_PPG
    else {
#endif
        //---------------------------------------------------------------------
        // skip "length of variable" bytes
        //---------------------------------------------------------------------
        src += 2;
        if (*dest     != 0xF8 ||
            *(dest-4) != 'p'  ||
            *(dest-3) != 'p'  ||
            *(dest-2) != 'g'  ||
            !ttunpack_valid(src))
        {
            if (h) HeapUnlock(h);
#ifndef ONLY_PPG
            fatal("neither ASM nor PPG file");
#else
            fatal("no PPG file");
#endif
        }
        //---------------------------------------------------------------------
        // get the original size and allocate memory for it
        //---------------------------------------------------------------------
        length = ttunpack_size(src);
#ifndef ONLY_PPG
    }
#endif

#endif


#ifndef ONLY_PPG
    if (do_alloc) {
#endif
        if (!(dest=malloc(length))) {
            if (h) HeapUnlock(h);
            fatal("out of memory");
        }

#ifndef ONLY_PPG
        if (asm_prg) {
            memcpy(dest,src,length);
        }
#endif

#ifndef ONLY_ASM

    #ifndef ONLY_PPG
        else {
    #endif
            ST_showHelp("decompressing ...");

            if (ttunpack_decompress(src,dest)) {
                //-------------------------------------------------------------
                // "houston we got problems ..."
                //-------------------------------------------------------------
                free(dest);
                if (h) HeapUnlock(h);
                fatal("failed");
            }
            ST_eraseHelp();
    #ifndef ONLY_PPG
        }
    #endif
    #ifndef ONLY_PPG
    }
    #endif

#else
    }
#endif

    //-------------------------------------------------------------------------
    // relocate the executable, enter the ghostspace and start it ...
    //-------------------------------------------------------------------------
    EX_patch(dest+0x40002,dest+length-1);
    own_enter_ghost_space();
    ASM_CALL_WITH_RETURN_VALUE_HANDLING(dest+0x40002,mode);

#ifndef ONLY_PPG
    if (src!=dest)
#endif
        free(dest);

    if (h) HeapUnlock(h);

#ifdef LEAKWATCH
    if ((freemem=((long)HeapAvail())-freemem) != 0) {
        sprintf(tmpstr, "mem changed by %ld", freemem);
        ST_showHelp(tmpstr);
    }
#endif

    if (!mode) {
        //---------------------------------------------------------------------
        // launched program uses RETURN_VALUE - handle it correctly
        // (VERY dirty trick originally implemented by Zeljko Juric in the
        //  TIGCC Library)
        //
        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        // define DIRTY_RESTORE_REGS is extremely DIRTY. It restores a number
        // of registers from a fixed offset on the stack.
        // I can only guarantee that it works correctly with TIGCC 0.91 and
        // optimization setting -Os.
        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        //---------------------------------------------------------------------
        asm volatile(DIRTY_RESTORE_REGS\
            "unlk %a6;move.l (%sp)+,%a0;cmpi.w #0x21EE,(%a0);"\
            "bne.s 0f;addq.l #2,%a0;0: jmp (%a0,4)");
    }
}

//#############################################################################
//###################### NO MORE FAKES BEYOND THIS LINE #######################
//#############################################################################
//
//=============================================================================
// Revision History
//=============================================================================
//
// $Log: ttstart.c,v $
// Revision 1.9  2001/07/31 22:56:59  Thomas Nussbaumer
// generic commit for Tools Suite version 0.99.10
//
// Revision 1.8  2001/02/04 16:45:40  Thomas Nussbaumer
// using new ttunpack.h version
//
// Revision 1.7  2000/11/18 16:00:18  Thomas Nussbaumer
// enter_ghost_space() added
//
// Revision 1.6  2000/10/01 14:56:52  Thomas Nussbaumer
// support for custom start utility build added
//
// Revision 1.5  2000/08/30 20:01:55  Thomas Nussbaumer
// using now assembler optimized version of unpack routine
//
// Revision 1.4  2000/08/30 19:44:24  Thomas Nussbaumer
// TABs replaced by spaces and trailing spaces removed
//
// Revision 1.3  2000/08/20 15:28:22  Thomas Nussbaumer
// including of unpack.c done now before including ttunpack.h
//
// Revision 1.2  2000/08/16 22:29:05  Thomas Nussbaumer
// (1) based now on shared file unpack.c
// (2) argument can be specified on commandline
// (3) define and code for time measurement integrated
//
// Revision 1.1  2000/08/14 22:48:38  Thomas Nussbaumer
// initial version
//
//
